FS/XFS testing framework
 help / color / mirror / Atom feed
From: Ojaswin Mujoo <ojaswin@linux.ibm.com>
To: Zorro Lang <zlang@redhat.com>, fstests@vger.kernel.org
Cc: Ritesh Harjani <ritesh.list@gmail.com>,
	djwong@kernel.org, john.g.garry@oracle.com, tytso@mit.edu,
	linux-xfs@vger.kernel.org, linux-kernel@vger.kernel.org,
	linux-ext4@vger.kernel.org
Subject: [PATCH v4 04/11] generic: Add atomic write test using fio crc check verifier
Date: Sun, 10 Aug 2025 19:11:55 +0530	[thread overview]
Message-ID: <783e950d8b5ad80672a359a19ede4faeb64e3dd7.1754833177.git.ojaswin@linux.ibm.com> (raw)
In-Reply-To: <cover.1754833177.git.ojaswin@linux.ibm.com>

This adds atomic write test using fio based on it's crc check verifier.
fio adds a crc for each data block. If the underlying device supports
atomic write then it is guaranteed that we will never have a mix data from
two threads writing on the same physical block.

Avoid doing overlapping parallel atomic writes because it might give
unexpected results. Use offset_increment=, size= fio options to achieve
this behavior.

Co-developed-by: Ritesh Harjani (IBM) <ritesh.list@gmail.com>
Signed-off-by: Ritesh Harjani (IBM) <ritesh.list@gmail.com>
Signed-off-by: Ojaswin Mujoo <ojaswin@linux.ibm.com>
---
 tests/generic/1226     | 107 +++++++++++++++++++++++++++++++++++++++++
 tests/generic/1226.out |   2 +
 2 files changed, 109 insertions(+)
 create mode 100755 tests/generic/1226
 create mode 100644 tests/generic/1226.out

diff --git a/tests/generic/1226 b/tests/generic/1226
new file mode 100755
index 00000000..efc360e1
--- /dev/null
+++ b/tests/generic/1226
@@ -0,0 +1,107 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2025 IBM Corporation. All Rights Reserved.
+#
+# FS QA Test 1226
+#
+# Validate FS atomic write using fio crc check verifier.
+#
+. ./common/preamble
+. ./common/atomicwrites
+
+_begin_fstest auto aio rw atomicwrites
+
+_require_scratch_write_atomic
+_require_odirect
+_require_aio
+
+_scratch_mkfs >> $seqres.full 2>&1
+_scratch_mount
+_require_xfs_io_command "falloc"
+
+touch "$SCRATCH_MNT/f1"
+awu_min_write=$(_get_atomic_write_unit_min "$SCRATCH_MNT/f1")
+awu_max_write=$(_get_atomic_write_unit_max "$SCRATCH_MNT/f1")
+
+blocksize=$(_max "$awu_min_write" "$((awu_max_write/2))")
+threads=$(_min "$(($(nproc) * 2 * LOAD_FACTOR))" "100")
+filesize=$((blocksize * threads * 100))
+depth=$threads
+io_size=$((filesize / threads))
+io_inc=$io_size
+testfile=$SCRATCH_MNT/test-file
+
+fio_config=$tmp.fio
+fio_out=$tmp.fio.out
+
+fio_aw_config=$tmp.aw.fio
+fio_verify_config=$tmp.verify.fio
+
+function create_fio_configs()
+{
+	create_fio_aw_config
+	create_fio_verify_config
+}
+
+function create_fio_verify_config()
+{
+cat >$fio_verify_config <<EOF
+	[verify-job]
+	direct=1
+	ioengine=libaio
+	rw=read
+	bs=$blocksize
+	filename=$testfile
+	size=$filesize
+	iodepth=$depth
+	group_reporting=1
+
+	verify_only=1
+	verify=crc32c
+	verify_fatal=1
+	verify_state_save=0
+	verify_write_sequence=0
+EOF
+}
+
+function create_fio_aw_config()
+{
+cat >$fio_aw_config <<EOF
+	[atomicwrite-job]
+	direct=1
+	ioengine=libaio
+	rw=randwrite
+	bs=$blocksize
+	filename=$testfile
+	size=$io_inc
+	offset_increment=$io_inc
+	iodepth=$depth
+	numjobs=$threads
+	group_reporting=1
+	atomic=1
+
+	verify_state_save=0
+	verify=crc32c
+	do_verify=0
+EOF
+}
+
+create_fio_configs
+_require_fio $fio_aw_config
+
+cat $fio_aw_config >> $seqres.full
+cat $fio_verify_config >> $seqres.full
+
+$XFS_IO_PROG -fc "falloc 0 $filesize" $testfile >> $seqres.full
+
+$FIO_PROG $fio_aw_config >> $seqres.full
+ret1=$?
+$FIO_PROG $fio_verify_config >> $seqres.full
+ret2=$?
+
+[[ $ret1 -eq 0 && $ret2 -eq 0 ]] || _fail "fio with atomic write failed"
+
+# success, all done
+echo Silence is golden
+status=0
+exit
diff --git a/tests/generic/1226.out b/tests/generic/1226.out
new file mode 100644
index 00000000..6dce0ea5
--- /dev/null
+++ b/tests/generic/1226.out
@@ -0,0 +1,2 @@
+QA output created by 1226
+Silence is golden
-- 
2.49.0


  parent reply	other threads:[~2025-08-10 13:42 UTC|newest]

Thread overview: 38+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2025-08-10 13:41 [PATCH v4 00/11] Add more tests for multi fs block atomic writes Ojaswin Mujoo
2025-08-10 13:41 ` [PATCH v4 01/11] common/rc: Add _min() and _max() helpers Ojaswin Mujoo
2025-08-13 12:20   ` David Laight
2025-08-21 10:35     ` Ojaswin Mujoo
2025-08-10 13:41 ` [PATCH v4 02/11] common/rc: Add a helper to run fsx on a given file Ojaswin Mujoo
2025-08-10 13:41 ` [PATCH v4 03/11] ltp/fsx.c: Add atomic writes support to fsx Ojaswin Mujoo
2025-08-13 13:42   ` John Garry
2025-08-21  9:45     ` Ojaswin Mujoo
2025-08-10 13:41 ` Ojaswin Mujoo [this message]
2025-08-12 17:16   ` [PATCH v4 04/11] generic: Add atomic write test using fio crc check verifier Darrick J. Wong
2025-08-13 13:39   ` John Garry
2025-08-21  8:42     ` Ojaswin Mujoo
2025-08-21  9:24       ` John Garry
2025-08-21 12:18         ` Ojaswin Mujoo
2025-08-10 13:41 ` [PATCH v4 05/11] generic: Add atomic write test using fio verify on file mixed mappings Ojaswin Mujoo
2025-08-12 17:16   ` Darrick J. Wong
2025-08-10 13:41 ` [PATCH v4 06/11] generic: Add atomic write multi-fsblock O_[D]SYNC tests Ojaswin Mujoo
2025-08-11 15:29   ` Darrick J. Wong
2025-08-10 13:41 ` [PATCH v4 07/11] generic: Stress fsx with atomic writes enabled Ojaswin Mujoo
2025-08-12 17:18   ` Darrick J. Wong
2025-08-13  5:45     ` Ojaswin Mujoo
2025-08-10 13:41 ` [PATCH v4 08/11] generic: Add sudden shutdown tests for multi block atomic writes Ojaswin Mujoo
2025-08-10 13:42 ` [PATCH v4 09/11] ext4: Atomic writes stress test for bigalloc using fio crc verifier Ojaswin Mujoo
2025-08-12  8:08   ` John Garry
2025-08-13  7:08     ` Ojaswin Mujoo
2025-08-13  7:33       ` John Garry
2025-08-21  8:29         ` Ojaswin Mujoo
2025-08-10 13:42 ` [PATCH v4 10/11] ext4: Atomic writes test for bigalloc using fio crc verifier on multiple files Ojaswin Mujoo
2025-08-13 13:45   ` John Garry
2025-08-21  8:28     ` Ojaswin Mujoo
2025-08-21  9:28       ` John Garry
2025-08-21 12:19         ` Ojaswin Mujoo
2025-08-10 13:42 ` [PATCH v4 11/11] ext4: Atomic write test for extent split across leaf nodes Ojaswin Mujoo
2025-08-12 17:19   ` Darrick J. Wong
2025-08-13  5:45     ` Ojaswin Mujoo
2025-08-13 13:54   ` John Garry
2025-08-21  8:25     ` Ojaswin Mujoo
2025-08-21  9:23       ` John Garry

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=783e950d8b5ad80672a359a19ede4faeb64e3dd7.1754833177.git.ojaswin@linux.ibm.com \
    --to=ojaswin@linux.ibm.com \
    --cc=djwong@kernel.org \
    --cc=fstests@vger.kernel.org \
    --cc=john.g.garry@oracle.com \
    --cc=linux-ext4@vger.kernel.org \
    --cc=linux-kernel@vger.kernel.org \
    --cc=linux-xfs@vger.kernel.org \
    --cc=ritesh.list@gmail.com \
    --cc=tytso@mit.edu \
    --cc=zlang@redhat.com \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox